/*!
ng2-dynamic-forms 1.4.7 2017-05-01 12:23 UTC
Copyright (c) 2016, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
import { Component, ContentChildren, EventEmitter, Input, NgModule, Output, QueryList } from '@angular/core';
import { FormGroup, ReactiveFormsModule } from '@angular/forms';
import { DynamicFormControlComponent, DynamicFormControlModel, DynamicFormRelationService, DynamicFormsCoreModule, DynamicTemplateDirective } from '@ng2-dynamic-forms/core';
import { CommonModule } from '@angular/common';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var DynamicFormBootstrapComponent = (function (_super) {
    __extends(DynamicFormBootstrapComponent, _super);
    function DynamicFormBootstrapComponent(relationService) {
        var _this = _super.call(this, relationService) || this;
        _this.bindId = true;
        _this.asBootstrapFormGroup = true;
        _this.hasErrorMessaging = false;
        _this.blur = new EventEmitter();
        _this.change = new EventEmitter();
        _this.focus = new EventEmitter();
        return _this;
    }
    Object.defineProperty(DynamicFormBootstrapComponent.prototype, "controlGroup", {
        set: function (group) {
            this.group = group;
            console.warn("[controlGroup] is deprecated. Use [group] instead.");
        },
        enumerable: true,
        configurable: true
    });
    return DynamicFormBootstrapComponent;
}(DynamicFormControlComponent));
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DynamicFormBootstrapComponent.prototype, "bindId", void 0);
__decorate([
    Input(),
    __metadata("design:type", FormGroup),
    __metadata("design:paramtypes", [FormGroup])
], DynamicFormBootstrapComponent.prototype, "controlGroup", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DynamicFormBootstrapComponent.prototype, "asBootstrapFormGroup", void 0);
__decorate([
    Input(),
    __metadata("design:type", FormGroup)
], DynamicFormBootstrapComponent.prototype, "group", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean)
], DynamicFormBootstrapComponent.prototype, "hasErrorMessaging", void 0);
__decorate([
    Input(),
    __metadata("design:type", DynamicFormControlModel)
], DynamicFormBootstrapComponent.prototype, "model", void 0);
__decorate([
    Input(),
    __metadata("design:type", QueryList)
], DynamicFormBootstrapComponent.prototype, "nestedTemplates", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], DynamicFormBootstrapComponent.prototype, "blur", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], DynamicFormBootstrapComponent.prototype, "change", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], DynamicFormBootstrapComponent.prototype, "focus", void 0);
__decorate([
    ContentChildren(DynamicTemplateDirective),
    __metadata("design:type", QueryList)
], DynamicFormBootstrapComponent.prototype, "templates", void 0);
DynamicFormBootstrapComponent = __decorate([
    Component({
        selector: "dynamic-form-bootstrap-control",
        template: "<div [class.form-group]=\"asBootstrapFormGroup || model.cls.element.container.includes('form-group')\" [class.has-error]=\"hasErrorMessaging && !hasFocus && isInvalid\" [formGroup]=\"group\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\"><label *ngIf=\"type !== 2 && model.label !== null\" [attr.for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></label><ng-template *ngIf=\"hasStartTemplate && type !== 1\" [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"model\"></ng-template><div *ngIf=\"type === 2\" [ngClass]=\"model.cls.grid.control\"><div class=\"checkbox\" [class.disabled]=\"model.disabled\"><label><input type=\"checkbox\" [attr.tabindex]=\"model.tabIndex\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" [value]=\"model.value\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><span [innerHTML]=\"model.label\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\"></span></label></div></div><div *ngIf=\"type !== 2\" [ngClass]=\"model.cls.grid.control\"><ng-container [ngSwitch]=\"type\"><div *ngSwitchCase=\"1\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let groupModel of model.groups; let idx = index\" [formGroupName]=\"idx\"><dynamic-form-bootstrap-control *ngFor=\"let controlModel of groupModel.group\" [bindId]=\"false\" [group]=\"control.at(idx)\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templateDirectives\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-bootstrap-control><ng-template [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"groupModel\"></ng-template></fieldset></div><fieldset *ngSwitchCase=\"3\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><dynamic-form-bootstrap-control *ngFor=\"let controlModel of model.group\" [asBootstrapFormGroup]=\"false\" [group]=\"control\" [hasErrorMessaging]=\"controlModel.hasErrorMessages\" [model]=\"controlModel\" [nestedTemplates]=\"templateDirectives\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></dynamic-form-bootstrap-control></fieldset><div *ngSwitchCase=\"4\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\" [innerHTML]=\"model.prefix\"></div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [attr.tabindex]=\"model.tabIndex\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\" [innerHTML]=\"model.suffix\"></div><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"5\" role=\"radiogroup\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [name]=\"model.name\" (change)=\"onValueChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><div *ngFor=\"let option of model.options\" class=\"radio\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [value]=\"option.value\" (blur)=\"onFocusChange($event)\" (focus)=\"onFocusChange($event)\"><span [innerHTML]=\"option.label\"></span></label></div></fieldset><select *ngSwitchCase=\"6\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [required]=\"model.required\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"><option *ngFor=\"let option of model.options\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><textarea *ngSwitchCase=\"8\" class=\"form-control\" [attr.tabindex]=\"model.tabIndex\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" (blur)=\"onFocusChange($event)\" (change)=\"onValueChange($event)\" (focus)=\"onFocusChange($event)\"></textarea><span *ngIf=\"model.hint\" class=\"help-block\" [innerHTML]=\"model.hint\" [ngClass]=\"model.cls.element.hint\"></span></ng-container></div><ul *ngIf=\"hasErrorMessaging\" class=\"has-error\" [class.hidden]=\"!showErrorMessages\" [ngClass]=\"[model.cls.element.errors, model.cls.grid.errors]\"><li *ngFor=\"let message of errorMessages\" class=\"help-block\">{{message}}</li></ul><ng-template *ngIf=\"hasEndTemplate && type !== 1\" [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"model\"></ng-template><ng-content></ng-content></div>"
    }),
    __metadata("design:paramtypes", [DynamicFormRelationService])
], DynamicFormBootstrapComponent);

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var DynamicFormsBootstrapUIModule = (function () {
    function DynamicFormsBootstrapUIModule() {
    }
    return DynamicFormsBootstrapUIModule;
}());
DynamicFormsBootstrapUIModule = __decorate$1([
    NgModule({
        imports: [
            CommonModule,
            ReactiveFormsModule,
            DynamicFormsCoreModule
        ],
        declarations: [
            DynamicFormBootstrapComponent
        ],
        exports: [
            DynamicFormsCoreModule,
            DynamicFormBootstrapComponent
        ]
    })
], DynamicFormsBootstrapUIModule);

export { DynamicFormBootstrapComponent, DynamicFormsBootstrapUIModule };
